
#ifndef BOOST_MPL_DEQUE_HPP_INCLUDED
#define BOOST_MPL_DEQUE_HPP_INCLUDED

// Copyright Aleksey Gurtovoy 2000-2004
//
// Distributed under the Boost Software License, Version 1.0. 
// (See accompanying file LICENSE_1_0.txt or copy at 
// http://www.boost.org/LICENSE_1_0.txt)
//
// See http://www.boost.org/libs/mpl for documentation.

// $Source: /cvsroot/boost/boost/boost/mpl/Attic/deque.hpp,v $
// $Date: 2004/11/10 21:06:20 $
// $Revision: 1.1.2.1 $

#if !defined(BOOST_MPL_PREPROCESSING_MODE)
#   include <dkutil/boost/mpl/limits/vector.hpp>
#   include <dkutil/boost/mpl/aux_/na.hpp>
#   include <dkutil/boost/mpl/aux_/config/preprocessor.hpp>

#   include <dkutil/boost/preprocessor/inc.hpp>
#   include <dkutil/boost/preprocessor/cat.hpp>
#   include <dkutil/boost/preprocessor/stringize.hpp>

#if !defined(BOOST_NEEDS_TOKEN_PASTING_OP_FOR_TOKENS_JUXTAPOSING)
#   define AUX778076_DEQUE_HEADER \
    BOOST_PP_CAT(vector, BOOST_MPL_LIMIT_VECTOR_SIZE).hpp \
    /**/
#else
#   define AUX778076_DEQUE_HEADER \
    BOOST_PP_CAT(vector, BOOST_MPL_LIMIT_VECTOR_SIZE)##.hpp \
    /**/
#endif

#   include BOOST_PP_STRINGIZE(dkutil/boost/mpl/vector/AUX778076_DEQUE_HEADER)
#   undef AUX778076_DEQUE_HEADER
#endif

#include <dkutil/boost/mpl/aux_/config/use_preprocessed.hpp>

#if !defined(BOOST_MPL_CFG_NO_PREPROCESSED_HEADERS) \
    && !defined(BOOST_MPL_PREPROCESSING_MODE)

#   define BOOST_MPL_PREPROCESSED_HEADER deque.hpp
#   include <dkutil/boost/mpl/aux_/include_preprocessed.hpp>

#else

#   include <dkutil/boost/mpl/limits/vector.hpp>

#   define AUX778076_SEQUENCE_NAME deque
#   define AUX778076_SEQUENCE_BASE_NAME vector
#   define AUX778076_SEQUENCE_LIMIT BOOST_MPL_LIMIT_VECTOR_SIZE
#   include <dkutil/boost/mpl/aux_/sequence_wrapper.hpp>

#endif // BOOST_MPL_CFG_NO_PREPROCESSED_HEADERS
#endif // BOOST_MPL_DEQUE_HPP_INCLUDED
